#define _WINSOCKAPI_
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "QueueDlg.h"
#include "Global.h"
#include "SmtpDlgs.h"
#include "FileMan.h"
#include "HeadMan.h"
#include "pgpmail.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TQueueForm *QueueForm;
//---------------------------------------------------------------------------
bool __fastcall QueueMessage(TRichEdit *Editor, int WordWrap, int ClearText,
   bool UseDialog)
{
   bool locked,ww=Editor->WordWrap,ok=true;
   locked = LockWindowUpdate(((TForm*)Editor->Owner)->Handle);
   if (ww) Editor->WordWrap = false;
   // remove any previous error messages from top of message
   while (Editor->Lines->Count && Editor->Lines->Strings[0].SubString(1,1)=="#")
      Editor->Lines->Delete(0);
   // add wordwrap header
   Editor->Lines->Insert(0,WordWrapHeader+AnsiString(WordWrap));
   // add cleartext header if cleartext is available
   QSPoolClearTextToHeader(Editor->Lines,ClearText);

   // queue
   QueueForm = new TQueueForm(Editor->Lines,Application->MainForm);
   if (UseDialog) ok = QueueForm->Execute();
   else QueueForm->QueueMessage();
   delete QueueForm;

   // remove wordwrap header and rewrap
   Editor->Lines->Delete(0);
   if (ww) Editor->WordWrap = true;
   if (locked) LockWindowUpdate(0);

   return ok;
}
//---------------------------------------------------------------------------
__fastcall TQueueForm::TQueueForm(TComponent* Owner)
	: TForm(Owner)
{
   CenterDialog(this,AppMainForm);
   Message = NULL;
}
//---------------------------------------------------------------------------
__fastcall TQueueForm::TQueueForm(TStrings* message, TComponent* Owner)
	: TForm(Owner)
{
   CenterDialog(this,AppMainForm);
   Message = message;
}
//---------------------------------------------------------------------------
void __fastcall TQueueForm::FormShow(TObject *Sender)
{
   PostMessage(Handle,WM_QUEUESTART,0,0L);
}
//---------------------------------------------------------------------------
void __fastcall TQueueForm::WMQueueStart(TMessage& Msg)
{
//   Sleep(100);
//   Display->Caption = "...queueing...";
   AppProcessMessages();
   if (Message) QueueMessage();
   ModalResult = mrOk;
   Sleep(200);
}
//---------------------------------------------------------------------------
bool __fastcall TQueueForm::Execute()
{
   ShowModal();
   return ModalResult==mrOk;
}
//---------------------------------------------------------------------------
void __fastcall TQueueForm::QueueMessage()
{
   if (Message)
      PutAppData(MailQueue+PS+HeadMan->IndexString(Message),Message);
}
//---------------------------------------------------------------------------
